require "defines"

local train_list = {}
local loadouts = {}
local dumpers ={}

local find_load_unload = function()
	force = game.player.force
	if force.get_entity_count("hopper-dumper") > 0 then
		for chunk in game.players[1].surface.get_chunks() do
			for _, ent in ipairs(game.players[1].surface.find_entities_filtered{area={{chunk.x*32,chunk.y*32},{chunk.x*32+32,chunk.y*32+32}}, name="hopper-dumper"}) do
				--there could be an entity on a border - check it isn't a duplicate
				x = ent.position.x
				y = ent.position.y
				insert=true
				for _, exist_ent in ipairs(dumpers) do
					if (x == exist_ent.position.x) and (y == exist_ent.position.y) then
						insert=false
						break
					end
				end
				if insert == true then
					table.insert(dumpers, ent)
				end
				-- if force.get_entity_count("hopper-dumper") == table.getn(dumpers) then
					-- stop = true
					-- break
				-- end
			end
			
			-- if stop == true then
				-- break
			-- end
		end
	end
	if force.get_entity_count("hopper-loader") > 0 then
		for chunk in game.players[1].surface.get_chunks() do
			for _, ent in ipairs(game.players[1].surface.find_entities_filtered{area={{chunk.x*32,chunk.y*32},{chunk.x*32+32,chunk.y*32+32}}, name="hopper-loader"}) do
				--there could be an entity on a border - check it isn't a duplicate
				x = ent.position.x
				y = ent.position.y
				insert=true
				for _, exist_ent in ipairs(loadouts) do
					if (x == exist_ent.position.x) and (y == exist_ent.position.y) then
						insert=false
						break
					end
				end
				if insert == true then
					table.insert(loadouts, ent)
				end
				-- if force.get_entity_count("hopper-loader") == table.getn(loadouts) then
					-- stop = true
					-- break
				-- end
			end
			
			-- if stop == true then
				-- break
			-- end
		end
	end
	
	-- px = game.players[1].position.x
	-- py = game.players[1].position.y
	-- area = {{px-20, py-20},{px+20, py+20}}
	-- for _, ent in ipairs(game.players[1].surface.find_entities_filtered{area=area, name="hopper-dumper"}) do
		-- table.insert(dumpers, ent)
	-- end	
		
	-- for _, ent in ipairs(game.players[1].surface.find_entities_filtered{area=area, name="hopper-loader"}) do
		-- table.insert(loadouts, ent)
	-- end	
end

local set_load_flag = function()
	global.first_tick = true
end

script.on_load(set_load_flag)

local entityBuilt = function(event)
	local entity = event.created_entity
	-- game.player.print(entity.name)
	if entity.name == "hopper-loader" then
		table.insert(loadouts, entity)
	end
	if entity.name == "hopper-dumper" then
		table.insert(dumpers, entity)
	end
end

local entityDestroyed= function(event)
	local entity = event.entity
	if entity.name == "hopper-loader" then
		valid_vals = {}
		for _, ent in ipairs(loadouts) do
			if ent.valid then
				table.insert(valid_vals, ent)
			end
		end
		loadouts = valid_vals
	end
	if entity.name == "hopper-dumper" then
		valid_vals = {}
		for _, ent in ipairs(dumpers) do
			if ent.valid then
				table.insert(valid_vals, ent)
			end
		end
		dumpers = valid_vals
	end
end

local entityMined= function(event)
	local stack = event.item_stack
	if stack.name == "hopper-loader" then
		valid_vals = {}
		for _, ent in ipairs(loadouts) do
			if ent.valid then
				table.insert(valid_vals, ent)
			end
		end
		loadouts = valid_vals
	end
	if stack.name == "hopper-dumper" then
		valid_vals = {}
		for _, ent in ipairs(dumpers) do
			if ent.valid then
				table.insert(valid_vals, ent)
			end
		end
		dumpers = valid_vals
	end
end

local train_change= function(event)
	train = event.train	
	ok = true
	for existing_train,_ in pairs(train_list) do
		if train == existing_train then 
			ok = false
		end	
	end
	if ok then
		train_list[train] = true
	end
end

local transfer_items = function(ent1, ent2, max_items)
	-- Removes up to max_items from first available to insert item in ent1 and inserts it into entity 2
	inv1 = ent1.get_inventory(defines.inventory.chest)
	inv2 = ent2.get_inventory(defines.inventory.chest)
	-- get the first item
	for item, count in pairs(inv1.get_contents()) do
		if count < max_items then
			to_insert = count
		else
			to_insert = max_items
		end
		stack = {name=item, count=to_insert}
		if inv2.can_insert(stack) then
			inserted = inv2.insert(stack)
			inv1.remove({name=item, count = inserted})
			break
		end
	end
end


local on_tick =  function(event)
	if global.first_tick then
		find_load_unload()
		global.first_tick = false
	end
	if game.tick%6 == 0 then
		for _,loadout in ipairs(loadouts) do
			px = loadout.position.x
			py = loadout.position.y
			x1 = px - 1.5
			x2 = px + 1.5
			y1 = py - 1.5
			y2 = py + 1.5
			
			area = {{x1,y1},{x2,y2}}
			for _, belt in ipairs(loadout.surface.find_entities_filtered{area=area, type="transport-belt"}) do
				i = 1
				while i <= 2 do
					items = belt.get_transport_line(i).get_contents()
					for name, count in pairs(items) do
						inserted = loadout.insert({name=name, count = count})
						if inserted > 0 then
							belt.remove_item({name=name, count = inserted})
						end
					end
				i = i + 1
				end
			end
		end
		
		for _,dumper in ipairs(dumpers) do
			
			if dumper.has_items_inside() then
				px = dumper.position.x
				py = dumper.position.y
				x1 = px - 1.5
				x2 = px + 1.5
				y1 = py - 1.5
				y2 = py + 1.5
				
				area = {{x1,y1},{x2,y2}}

				for _, belt in ipairs(dumper.surface.find_entities_filtered{area=area, type="transport-belt"}) do
					i = 1
					while i <= 2 do
						items = dumper.get_inventory(defines.inventory.chest).get_contents()
						for item, count in pairs(items) do
							stack = {name=item, count=1}
							if belt.get_transport_line(i).insert_at_back(stack) then
								dumper.remove_item(stack)
							end
							break
						end
						i = i+ 1
					end
				end
			end
		end
	end
	if (game.tick%12) == 0 then
		
		for _, loadout in ipairs(loadouts) do
			-- game.player.print(_)
			if loadout.has_items_inside() then
				px = loadout.position.x
				py = loadout.position.y
				
				x1 = px - 1
				x2 = px + 1
				y1 = py - 1
				y2 = py + 1
					
				for _, hopper in ipairs(loadout.surface.find_entities_filtered{area={{x1, y1}, {x2, y2}}, name="hopper-wagon"}) do
					if ((hopper.train.speed <= 0) and (hopper.train.speed > -0.09)) or ((hopper.train.speed >= 0) and (hopper.train.speed < 0.09)) then
						transfer_items(loadout, hopper, 20)
					end
					
				end
		
			end
		end
	end
	
	if ((game.tick+5)%12) == 0 then
		
		for _, dumper in ipairs(dumpers) do
			px = dumper.position.x
			py = dumper.position.y

			x1 = px - 1
			x2 = px + 1
			y1 = py - 1
			y2 = py + 1
			
			for _, hopper in ipairs(dumper.surface.find_entities_filtered{area={{x1, y1}, {x2, y2}}, name="hopper-wagon"}) do
				-- if hopper.valid then game.player.print("true") end
				if hopper.has_items_inside() and(((hopper.train.speed <= 0) and (hopper.train.speed > -0.09)) or ((hopper.train.speed >= 0) and (hopper.train.speed < 0.09))) then
					transfer_items(hopper, dumper, 20)
					break
				end
			end

		end
	end
	
	for train, bool in pairs(train_list) do
		
		if train.valid then
			if train.speed < 0 then
				rail = train.back_rail
				mult = -1
				else
				rail = train.front_rail
				mult = 1
			end
			if rail ~= nil then
				if (rail.name == "slow-straight-rail") or (rail.name == "slow-curved-rail") then

					temp = train.speed*mult
					target_speed = 0.005
					-- game.player.print("actual:"..temp.."  target:"..target_speed)
					if temp > target_speed then
						temp = temp*.9
						if temp < target_speed then
							temp = target_speed
						end
					end
					train.speed = temp*mult
					-- game.players[1].print(train.speed)
				end
			end
		else

			train_list[train] = nil
		end
	end
end


	-- if game.tick%60 == 0 then

		-- i = 1
		-- px = game.players[1].position.x
		-- py = game.players[1].position.y
		-- for _, item in pairs(game.players[1].surface.find_entities_filtered{area={{px-2, py-2}, {px+2, py+2}}, name="wooden-chest"}) do
			-- if i==1 then
				-- item1 = item
				-- i = i+1
			-- elseif i == 2 then
				-- item2 = item
				-- i = i +1
				-- break
			-- end
		-- end
		-- if i == 3 then
			-- transfer_items(item1, item2, 20)
		-- end
	-- end
	
-- local on_tick =  function(event)
	-- for _, slow_rail in ipairs(slow_rails) do
		-- for _, veh in ipairs(slow_rail.surface.find_entities_filtered{area={{slow_rail.position.x-.1, slow_rail.position.y-.1},
																		-- {slow_rail.position.x+.1, slow_rail.position.y+.1}}, 
																		-- name="hopper-wagon"}) do
				-- if veh.train.speed > 0.008 then
					-- veh.train.speed = veh.train.speed*.92
					-- if veh.train.speed < 0.008 then
						-- veh.train.speed = 0.008
					-- end
				-- end
		-- end
	-- end
-- end

script.on_event(defines.events.on_tick, on_tick)
script.on_event(defines.events.on_train_changed_state, train_change)

script.on_event(defines.events.on_built_entity, entityBuilt)
script.on_event(defines.events.on_robot_built_entity, entityBuilt)

script.on_event(defines.events.on_entity_died, entityDestroyed)
script.on_event(defines.events.on_player_mined_item, entityMined)
script.on_event(defines.events.on_robot_mined, entityMined)