local hopper_wagon = copyPrototype("cargo-wagon", "cargo-wagon", "hopper-wagon")
hopper_wagon.weight=80
hopper_wagon.inventory_size=4
data:extend({hopper_wagon})

local slow_straight_rail = copyPrototype("straight-rail", "straight-rail", "slow-straight-rail")
local slow_curved_rail = copyPrototype("curved-rail", "curved-rail", "slow-curved-rail")
data:extend({slow_straight_rail})
data:extend({slow_curved_rail})
data:extend(
{{
    type = "container",
    name = "hopper-dumper",
    icon = "__base__/graphics/icons/iron-chest.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "hopper-dumper"},
	collision_mask = { "ghost-layer"},
    max_health = 1000,
    corpse = "big-remnants",
    dying_explosion = "medium-explosion",
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    resistances =
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-2, -2}, {2, 2}},
    selection_box = {{-2., -2.}, {2., 2.}},
    inventory_size = 100,
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__base__/graphics/entity/iron-chest/iron-chest.png",
      priority = "extra-high",
      width = 48,
      height = 34,
      shift = {0.2, 0}
    }
  },
  {
    type = "container",
    name = "hopper-loader",
    icon = "__base__/graphics/icons/iron-chest.png",
    flags = {"placeable-neutral", "player-creation"},
	collision_mask = { "ghost-layer"},
    minable = {mining_time = 1, result = "hopper-loader"},
    max_health = 1000,
    corpse = "big-remnants",
    dying_explosion = "medium-explosion",
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    resistances =
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-2, -2}, {2, 2}},
    selection_box = {{-2., -2.}, {2., 2.}},
    inventory_size = 100,
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__base__/graphics/entity/iron-chest/iron-chest.png",
      priority = "extra-high",
      width = 113,
      height = 99,
      shift = {0.2, 0}
    }
  }
}
)